{$R+,V+}

program moteur; {TRAU Patrick 3/6/88}

uses crt;
{version TP5. la seule chose qui change par rapport  la version TP3
 est le Uses ci dessus, et les read(kbd) changs en inkey}


TYPE tstring=string[80];
     t_action=(mu,mz,lire,dire,aff,stop);{action possible dans une conclusion}
     t_etat=(vrai,faux,inconnu,connu{seult pour une condition},texte);
     p_predicat=^t_predicat;
     t_predicat=record
                  etat:t_etat;
                  text:tstring;
                  suiv:p_predicat {ce n'est que pour faire un "tableau" des prdicats }
                end;
     p_condition=^t_condition;
     t_condition=record
                    genr:t_etat;
                    pred:p_predicat;{predicat associe}
                    suiv:p_condition{condition suivante dans la regle actuelle}
                  end;
     p_conclusion=^t_conclusion;
     t_conclusion=record
                     acti:t_action;
                     pred:p_predicat;{predicat associe}
                     suiv:p_conclusion{conclusion suivante dans la regle}
                   end;
     p_regle=^t_regle;
     t_regle=record
               num:integer; {ne sert qu' l'affichage}
               cond:p_condition; {liste de conditions}
               conc:p_conclusion; {liste de conclusions}
               suiv:p_regle
             end;

const blancs:set of char=[' ',#9];

     {mots clef du langage. Ce serait mieux si defini par l'utilisateur}
      premier_passage='PREMIER PASSAGE';
      dernier_passage='DERNIER PASSAGE';
      toujours_vrai='VRAI';
      arreter='STOP';

     {pour pouvoir afficher un type enumere}
      genres:array[0..4]of tstring=('Vrai','Faux','Inconnu','Connu','Texte');

var prem_regle:p_regle;
    prem_pred,adr_premtour,adr_derntour:p_predicat;
    nb_regles:integer;

{pour tourner}
var etape:integer;
    arret,premtour,derntour,derntourplus1:boolean;
    regle:p_regle; {rgle acuelle en traitement}
    details:integer;{niveau de dtails demands  l'affichage}
    dern_modif:integer;

function majuscule_c(c:char):char;
{met le caractre en majuscules, mme s'il comporte un accent}
begin
    if c in ['a'..'z'] then c:=upcase(c)
    else if c>#127 then
      if c in ['','',''] then c:='A'
      else if c in ['','','',''] then c:='E'
      else if c in ['',''] then c:='I'
      else if c in ['',''] then c:='O'
      else if c in ['','',''] then c:='U';
    majuscule_c:=c
end;

function majuscule_s(ent:tstring):tstring;
{met en majuscules toute une chaine de caractres}
var i:integer;
begin
  for i:=1 to length(ent) do ent[i]:=majuscule_c(ent[i]);
  majuscule_s:=ent
end;

function debut(var texte:tstring;mot_clef:tstring):boolean;
{dit si le mot clef commence le texte, si oui enlve le mot clef et blancs}
var i,it,im:integer;
    tbis:tstring;
    oui:boolean;
begin
  if (texte[length(mot_clef)+1] in blancs)
       or(length(mot_clef)=length(texte)) then begin
    oui:=true;
    for i:=1 to length(mot_clef) do
      if majuscule_c(texte[i])<>{upcase}(mot_clef[i]) then oui:=false;
    if oui then begin
      it:=length(mot_clef)+2;
      while (texte[it] in blancs)and(it<length(texte)) do it:=it+1;
      im:=1;
      for i:=it to length(texte) do begin
        tbis[im]:=texte[i];
        im:=im+1
      end;
      tbis[0]:=chr(im-1); {longueur juste}
      texte:=tbis
    end;
    debut:=oui
  end else debut:=false
end;

procedure cherche_cree_pred(texte:tstring;var adresse:p_predicat);
{cherche si le prdicat correspondant au texte existe et rend son adresse}
{s'il n'existe pas, il est cr}
var actu_pred:p_predicat;
    creer:boolean;
    texte_maj:tstring;
begin
  creer:=true;
  if prem_pred<>nil then begin
    actu_pred:=prem_pred;
    texte_maj:=majuscule_s(texte);
    while(actu_pred^.suiv<>nil)and(majuscule_s(actu_pred^.text)<>texte_maj)do
                            actu_pred:=actu_pred^.suiv;
    if majuscule_s(actu_pred^.text)=texte_maj then begin
      creer:=false;
      adresse:=actu_pred;
      if details>=2 then writeln(texte,': dj rencontr');
    end;
  end;
  if creer then begin
      if details>=2 then writeln(texte,': 1re rencontre');
      new(adresse);
      if prem_pred=nil then prem_pred:=adresse
                       else actu_pred^.suiv:=adresse;
      adresse^.suiv:=nil;
{prdicats prdfinis}
      if debut(texte,premier_passage)then begin
        adresse^.etat:=vrai;
        adresse^.text:=premier_passage;
        adr_premtour:=adresse
      end else if debut(texte,toujours_vrai) then begin
        adresse^.etat:=vrai;
        adresse^.text:=toujours_vrai
      end else if debut(texte,dernier_passage) then begin
        adresse^.etat:=faux;
        adresse^.text:=dernier_passage;
        adr_derntour:=adresse
      end else if debut(texte,arreter) then begin
        adresse^.etat:=faux;
        adresse^.text:=arreter
      end else begin
        adresse^.etat:=inconnu;
        adresse^.text:=texte
      end;
  end
end;

procedure lecture_bdc(nomfic:tstring);
{lecture du fichier, cration des listes de pointeurs, initialisations}
var f:text;
    ligne:tstring;
    actu_pred,aux_pred:p_predicat;
    actu_regle,prec_regle:p_regle;
    actu_cond,prec_cond:p_condition;
    actu_conc,prec_conc:p_conclusion;

begin
  assign(f,nomfic);
  reset(f);
  nb_regles:=0;
  actu_regle:=nil;
  prem_pred:=nil;
  adr_premtour:=nil;
  adr_derntour:=nil;
  arret:=false;
  if details=0 then write('->');
  while not eof(f) do begin
    readln(f,ligne);
    {virer les blancs en fin de ligne}
    while ligne[length(ligne)]in blancs do ligne[0]:=chr(length(ligne)-1);
    if debut(ligne,'SI') then begin
      prec_regle:=actu_regle;
      nb_regles:=nb_regles+1;
      if details>=1 then writeln('lecture rgle n ',nb_regles)
      else begin gotoxy(wherex-1,wherey);write('->') end;
      if details>=2 then begin
        write('appuyez CR pour continuer');readln;
        writeln('1re condition : ',ligne)
      end;
          new(actu_regle);
      actu_regle^.num:=nb_regles;
      if prec_regle=nil then prem_regle:=actu_regle
                        else prec_regle^.suiv:=actu_regle;
      new(actu_cond);
      actu_regle^.cond:=actu_cond;
      if debut(ligne,'NON CONNU') then actu_cond^.genr:=inconnu
        else if debut(ligne,'NON') then actu_cond^.genr:=faux
        else if debut(ligne,'INCONNU') then actu_cond^.genr:=inconnu
        else if debut(ligne,'CONNU') then actu_cond^.genr:=connu
        else actu_cond^.genr:=vrai;
      actu_cond^.suiv:=nil;
      cherche_cree_pred(ligne,actu_cond^.pred);
    end
    else if debut(ligne,'ET SI') then begin
      if details>=2 then writeln('Condition suivante : ',ligne);
      prec_cond:=actu_cond;
      new(actu_cond);
      prec_cond^.suiv:=actu_cond;
      actu_cond^.suiv:=nil;
      if debut(ligne,'NON CONNU') then actu_cond^.genr:=inconnu
        else if debut(ligne,'NON') then actu_cond^.genr:=faux
        else if debut(ligne,'INCONNU') then actu_cond^.genr:=inconnu
        else if debut(ligne,'CONNU') then actu_cond^.genr:=connu
        else actu_cond^.genr:=vrai;
      cherche_cree_pred(ligne,actu_cond^.pred);
    end
    else if debut(ligne,'ALORS') then begin
      if details>=2 then writeln('1re conclusion : ',ligne);
      new(actu_conc);
      actu_regle^.conc:=actu_conc;
      if debut(ligne,'NON') then actu_conc^.acti:=mz
        else if debut(ligne,'DEMANDER SI') then actu_conc^.acti:=lire
        else if debut(ligne,'DIRE SI') then actu_conc^.acti:=dire
        else if debut(ligne,'AFFICHER') then actu_conc^.acti:=aff
        else if debut(ligne,arreter) then begin actu_conc^.acti:=stop;ligne:=arreter end
        else actu_conc^.acti:=mu;
      actu_conc^.suiv:=nil;
      cherche_cree_pred(ligne,actu_conc^.pred);
      if actu_conc^.acti=aff then actu_conc^.pred^.etat:=texte
    end
    else if debut(ligne,'ET') then begin
      if details>=2 then writeln('Conclusion suivante : ',ligne);
      prec_conc:=actu_conc;
      new(actu_conc);
      prec_conc^.suiv:=actu_conc;
      if debut(ligne,'NON') then actu_conc^.acti:=mz
        else if debut(ligne,'DEMANDER SI') then actu_conc^.acti:=lire
        else if debut(ligne,'DIRE SI') then actu_conc^.acti:=dire
        else if debut(ligne,'AFFICHER') then actu_conc^.acti:=aff
        else if debut(ligne,arreter) then begin actu_conc^.acti:=stop;ligne:=arreter end
        else actu_conc^.acti:=mu;
      actu_conc^.suiv:=nil;
      cherche_cree_pred(ligne,actu_conc^.pred);
      if actu_conc^.acti=aff then actu_conc^.pred^.etat:=texte
    end
    else if details>=1 then writeln('COMMENTAIRE : ',ligne)
  end;
  close(f);
  actu_regle^.suiv:=nil;
  if details=0 then writeln;
  writeln(nb_regles,' rgles lues');
  etape:=0;
  regle:=prem_regle;
  dern_modif:=1;
  premtour:=true;
  derntour:=false;
end;

procedure execute_regle(regle:p_regle;var cestfait:boolean);
{xcute la rgle (test conditions puis faire actions)}
{dit si elle s'est applique ou non}
var condition:p_condition;
    conclusion:p_conclusion;
    cond_derntour,la_faire:boolean;
    c:char;
begin
  etape:=etape+1;
  if details>=1 then writeln('tape n ',etape,' : rgle n ',regle^.num);
  cestfait:=false;
  condition:=regle^.cond;
  cond_derntour:=false;
  la_faire:=true;
  while la_faire and(condition<>nil) do begin
    if details>=2 then begin
      writeln('TEST : ',genres[ord(condition^.genr)],' ',condition^.pred^.text);
      write('tat : ',genres[ord(condition^.pred^.etat)],' -> TEST ')
    end;
    la_faire:=((condition^.genr=connu)and(condition^.pred^.etat<>inconnu))
              or(condition^.genr=condition^.pred^.etat);
    if details>=2 then if la_faire then writeln('OK') else writeln('Refus');
    if condition^.pred=adr_derntour then cond_derntour:=true;
    condition:=condition^.suiv
  end;
  if la_faire then begin
    if details>=1 then writeln('la regle s''applique ');
    conclusion:=regle^.conc;
    while conclusion<>nil do begin
      case conclusion^.acti of
        mu:if conclusion^.pred^.etat<>vrai then begin
             conclusion^.pred^.etat:=vrai;
             if details>=2 then writeln(conclusion^.pred^.text,' mis  VRAI');
             cestfait:=true
           end;
        mz:if conclusion^.pred^.etat<>faux then begin
             conclusion^.pred^.etat:=faux;
             if details>=2 then writeln(conclusion^.pred^.text,' mis  FAUX');
             cestfait:=true
           end;
        lire:begin
               cestfait:=true;
               if details>=2 then writeln('ordre DEMANDER SI');
               writeln('est-ce que ',conclusion^.pred^.text);
               write('O/N/? : ');
               repeat c:=upcase(readkey) until c in ['O','N','?'];
               writeln(c);
               case c of
                 'O':conclusion^.pred^.etat:=vrai;
                 'N':conclusion^.pred^.etat:=faux;
                 '?':conclusion^.pred^.etat:=inconnu;
               end
             end;
        dire:begin
              if details>=2 then writeln('ordre DIRE SI');
              case conclusion^.pred^.etat of
                vrai:writeln('OUI, ',conclusion^.pred^.text);
                faux:writeln('IL EST FAUX QUE ',conclusion^.pred^.text);
                inconnu:writeln('JE NE SAIS SI ',conclusion^.pred^.text);
               end
             end;
        aff:begin
               if details>=2 then writeln('ordre AFFICHER');
               writeln(conclusion^.pred^.text);
             end;
        stop:begin
               writeln('arrt demand par rgle');
               arret:=true
             end;
      end;{case}
      if cond_derntour then begin
        if details>=2 then writeln('dernier passage remis  faux');
        adr_derntour^.etat:=faux;derntour:=false;cestfait:=true
      end;
      conclusion:=conclusion^.suiv
    end{while}
  end;{la faire}
end;

procedure pasapas;
{excute REGLE, puis passe  la suivante}
{raffecte variables pour 1er et dernier tour}
var ok:boolean;
    predicat:p_predicat;
begin
    execute_regle(regle,ok);
    if ok then dern_modif:=regle^.num;
    if regle^.suiv=nil then regle:=prem_regle else regle:=regle^.suiv;
    if premtour and(regle=prem_regle) then begin
      if details>=2 then writeln('---------------fin 1er passage');
      premtour:=false;
      if adr_premtour<>nil then adr_premtour^.etat:=faux;
    end;
    if (dern_modif=regle^.num) and(not derntour) then begin
      derntour:=true;
      if details>=2 then writeln('-----------------dernier passage');
      adr_derntour^.etat:=vrai;
    end;
end;

procedure tourne;
{faire tourner les rgles jusqu' condition d'arret}
begin
  repeat
    derntourplus1:=derntour;
    pasapas
  until (derntour and derntourplus1 and(dern_modif=regle^.num))or arret
end;

procedure nombrepas;
{Faire tourner un nombre donn d'tapes}
var n,i:integer;
begin
  write('nombre d''tapes  faire ? ');
  readln(n);
  i:=1;
  derntourplus1:=derntour;
  while (i<=n)and (not arret)and not(derntour and derntourplus1 and(dern_modif=regle^.num))do begin
    i:=i+1;
    derntourplus1:=derntour;
    pasapas
  end
end;

procedure lister;
{liste des prdicats (sur l'cran) }
var predicat:p_predicat;
    i:integer;
begin
  i:=0;
  predicat:=prem_pred;
  while predicat<>nil do begin
    if predicat^.etat<>texte then i:=i+1;
    if i>23 then begin
      i:=0;
      write('appuyer CR pour la suite : ');
      readln
    end;
    case predicat^.etat of
       vrai:writeln('VRAI : ',predicat^.text);
       faux:writeln('FAUX : ',predicat^.text);
       inconnu:writeln('-?-  : ',predicat^.text);
       texte:begin end {writeln('TXT  : ',predicat^.text)}
     end;
     predicat:=predicat^.suiv
  end;
  if i>15 then begin
      write('appuyer CR pour la suite : ');
      readln
  end
end;

procedure modif;
{modif manuelle des prdicats (liste de tous)}
{@@ il serait bien de les dplacer avec les flches et pointer pour modif}
var predicat:p_predicat;
    rep:char;
begin
  predicat:=prem_pred;
  while predicat<>nil do begin
    if predicat^.etat<>texte then begin
      case predicat^.etat of
         vrai:writeln('VRAI : ',predicat^.text);
         faux:writeln('FAUX : ',predicat^.text);
         inconnu:writeln('-?-  : ',predicat^.text)
       end;
       write('nouvel tat (V/F/?) <le mme> : ');
       repeat rep:=upcase(readkey) until rep in ['V','F','?',#13];
       if rep<>#13 then begin
         writeln(rep);
         case rep of
           'V':predicat^.etat:=vrai;
           'F':predicat^.etat:=faux;
           '?':predicat^.etat:=inconnu
         end
       end else writeln
     end;
     predicat:=predicat^.suiv
  end;
end;

procedure del_pointeurs;
{deleter tous les pointeurs (prdicats et rgles (et leurs conditions/conclusuions)}
  var pred:p_predicat;
      reg:p_regle;
      cd:p_condition;
      cc:p_conclusion;
begin
  while prem_pred<>nil do begin
    pred:=prem_pred^.suiv;
    dispose(prem_pred);
    prem_pred:=pred
  end;
  while prem_regle<>nil do begin
    reg:=prem_regle^.suiv;
    with prem_regle^ do begin
       while cond<>nil do begin
         cd:=cond^.suiv;
         dispose(cond);
         cond:=cd
       end;
       while conc<>nil do begin
         cc:=conc^.suiv;
         dispose(conc);
         conc:=cc
       end
    end;
    dispose(prem_regle);
    prem_regle:=reg
  end
end;

procedure list_BDC(nomfic:tstring);
{rcriture (propre) automatique de la BDC dans un fichier}
{rajoute en commentaire une cross-ref des prdicats}
const cd:array[0..3]of char=('V','F','?','C');
      cc:array[0..5]of char=('O','N','D','S','A','O');
var f:text;
    nu_regle,nb_p:integer;
    actu_pred:p_predicat;
    actu_regle:p_regle;
    actu_cond:p_condition;
    actu_conc:p_conclusion;

begin
  assign(f,nomfic);
  rewrite(f);
  nu_regle:=0;
  actu_regle:=prem_regle;
  actu_pred:=prem_pred;
  writeln(f);
  writeln(f,'        rcriture de la base de connaissances');
  writeln(f);
  writeln(f,'          suivie de l''analyse des prdicats');
  writeln(f);
  while actu_regle<>nil do begin
    nu_regle:=nu_regle+1;
    writeln(f,' - Rgle n ',nu_regle);
    with actu_regle^ do begin
      actu_cond:=cond;
      while actu_cond<>nil do begin
        if actu_cond=cond then write(f,'SI    ') else write(f,'ET SI ');
        case actu_cond^.genr of
          faux:write(f,'NON ');
          connu:write(f,'CONNU ');
          inconnu:write(f,'NON CONNU ')
        end;
        writeln(f,actu_cond^.pred^.text);
        actu_cond:=actu_cond^.suiv
      end;{while}
      actu_conc:=conc;
      while actu_conc<>nil do begin
        if actu_conc=conc then write(f,'ALORS ') else write(f,'ET    ');
        case actu_conc^.acti of
          mz:write(f,'NON ');
          lire:write(f,'DEMANDER SI ');
          dire:write(f,'DIRE SI ');
          aff:write(f,'AFFICHER ');
        end;
        writeln(f,actu_conc^.pred^.text);
        actu_conc:=actu_conc^.suiv
      end;{while}
    end;
    writeln(f);
    actu_regle:=actu_regle^.suiv;
  end;{while}
  writeln(f);
  writeln(f,'               tude des prdicats');
  writeln(f,'              ---------------------');
  writeln(f);
  writeln(f,' notations : condition  : si vrai:V, faux:F, inconnu:?, connu:C');
  writeln(f,'             conclusion : Oui, Non, Demander, dire Si, Afficher');
  writeln(f);
  actu_pred:=prem_pred;
  nb_p:=0;
  while actu_pred<>nil do begin
    nb_p:=nb_p+1;
    writeln(f,'- p',nb_p:2,' : ',actu_pred^.text);
    write(f,' condition dans :');
    actu_regle:=prem_regle;
    while actu_regle<>nil do begin
      actu_cond:=actu_regle^.cond;
      while actu_cond<>nil do begin
        if actu_cond^.pred=actu_pred then
           write(f,actu_regle^.num:3,cd[ord(actu_cond^.genr)]);
        actu_cond:=actu_cond^.suiv
      end;
      actu_regle:=actu_regle^.suiv
    end;
    writeln(f);
    write(f,' conclusion dans:');
    actu_regle:=prem_regle;
    while actu_regle<>nil do begin
      actu_conc:=actu_regle^.conc;
      while actu_conc<>nil do begin
        if actu_conc^.pred=actu_pred then
          write(f,actu_regle^.num:3,cc[ord(actu_conc^.acti)]);
        actu_conc:=actu_conc^.suiv
      end;
      actu_regle:=actu_regle^.suiv
    end;
    actu_pred:=actu_pred^.suiv;
    writeln(f)
  end;
  close(f);
end;

procedure sauve_bdf(nomfic:tstring);
{sauvegarde de la base de faits (tat des prdicats)}
var pred:p_predicat;
    f:text;

begin
  assign(f,nomfic);
  rewrite(f);
  pred:=prem_pred;
  while pred<>nil do begin
    if pred^.etat<>texte then begin
      case pred^.etat of
        vrai:write(f,'V ');
        faux:write(f,'F ');
        inconnu:write(f,'? ')
      end;
      writeln(f,pred^.text)
    end;
    pred:=pred^.suiv
  end;
  close(f)
end;

procedure recup_bdf(nomfic:tstring);
{lecture d'une base de faits de dpart}
{Si le fichier ne contient pas tous les faits, les omis resteront }
{leur valeur prcdente}
var pred:p_predicat;
    f:text;
    lig:tstring;
begin
  assign(f,nomfic);
  reset(f);
  while not eof(f) do begin
    readln(f,lig);
    if debut(lig,'F')then
      begin cherche_cree_pred(lig,pred);pred^.etat:=faux end
    else if debut(lig,'V')then
      begin cherche_cree_pred(lig,pred);pred^.etat:=vrai end
    else if debut(lig,'?')then
      begin cherche_cree_pred(lig,pred);pred^.etat:=inconnu end
    else if length(lig)>0 then writeln('ligne incomprhensible : ',lig);
  end;
  close(f)
end;

procedure presentation;
var c:char;
    i:integer;
begin
  textbackground(2);
  clrscr;
  textbackground(7);textcolor(2);
  gotoxy(3, 2);writeln('                                                                            ');
  gotoxy(3, 3);writeln('                                                                            ');
  gotoxy(3, 4);writeln('                                      ');
  gotoxy(3, 5);writeln('                                                  ');
  gotoxy(3, 6);writeln('                                                    ');
  gotoxy(3, 7);writeln('                                                 ');
  gotoxy(3, 8);writeln('                                                        ');
  gotoxy(3, 9);writeln('                                                    ');
  gotoxy(3,10);writeln('                                               ');
  gotoxy(3,11);writeln('                                                                            ');
  gotoxy(3,12);writeln('                                                                            ');
  textbackground(0);textcolor(7);
  gotoxy(22,17);write(' Programm par Patrick TRAU juin 88 ');
  textbackground(2);textcolor(15);
  gotoxy(5,24);
  write('appuyez P pour une prsentation complte, D pour dbuter immdiatement');
  c:=readkey;
  textbackground(0);textcolor(7);
  clrscr;
  if upcase(c)='P' then begin
    writeln('Ce moteur d''infrence d''ordre zro permet de traiter de petits problmes');
    writeln('d''intelligence artificielle par rgles de production. Votre expertise doit');
    writeln('tre formule sous forme de rgles SI - ALORS, l''ensemble des rgles formant');
    writeln('la Base de Connaissances (BdC). On appelle CLAUSE ou PREDICAT une assertion');
    writeln('(phrase) qui peut tre soit VRAIE, soit FAUSSE, soit INCONNUE. L''ensemble');
    writeln('des tats des prdicats est appell Base de Faits (BdF). Le principe de');
    writeln('l''infrence (dduction) est  partir d''une base de faits de dpart,');
    writeln('d''appliquer les rgles qui augmenteront la BdF, et donc permetra d''appliquer');
    writeln('d''autres rgles, et ce jusqu'' ce que toutes les dductions possibles soient');
    writeln('effectues. Au dpart, le moteur met tous les prdicats  INCONNU, except');
    writeln('PREMIER PASSAGE qui est vrai lors du premier passage (tour complet) sur');
    writeln('l''ensemble des rgles, puis qui est mis  FAUX. Les prdicats sont mis ');
    writeln('VRAI soit parce qu''ils sont conclusion dans une rgle o tous les prdicats');
    writeln('condition sont vrais, soit par l''utilisateur lors d''une conclusion de type');
    writeln('DEMANDER SI, soit par l''option de modification de la BdF. Un prdicat peut');
    writeln('commencer par NON, il sera alors complment (SI NON prdicat ou');
    writeln('ALORS NON prdicat).');
    writeln;
    writeln('On peut sauver la BdF dans son tat actuel, pour reprendre une excution au');
    writeln('mme niveau plus tard. On peut aussi crer une BdF de dpart par un diteur');
    writeln('de texte. Les prdicats qui n''y sont pas prciss seront mis  INCONNU.');
    writeln;
    write(' appuyez une touche pour la suite');c:=readkey;clrscr;
    writeln('Format d''une rgle, telle que vous l''entrez dans le fichier BdC par un');
    writeln('diteur de texte quelconque :');
    writeln;
    writeln('SI prdicat condition');
    writeln('ET SI prdicat condition');
    writeln(' ...............');
    writeln('ALORS prdicat conclusion');
    writeln('ET prdicat conclusion');
    writeln(' ...............');
    writeln;
    writeln('Vous pouvez utiliser indiffremment des majuscules ou minuscules (mme');
    writeln('accentues). Toute ligne ne commencant pas en 1re colonne par un mot clef');
    writeln('SI - ET SI - ALORS - ET sera considre comme commentaire. Deux prdicats');
    writeln('seront gaux s''ils sont crits de la mme manire (attention aux erreurs de');
    writeln('frappe, utilisez l''option Analyse de la BdC pour les dtecter, ou regardez');
    writeln('le fichier de sauvegarde de la BdF pour une liste des prdicats).');
    writeln;
    write(' appuyez une touche pour la suite');c:=readkey;clrscr;
    writeln('Prdicats prdfinis utilisables en condition uniquement :');
    writeln;
    writeln('CONNU prdicat : vrai si prdicat est VRAI ou FAUX, FAUX si inconnu');
    writeln('INCONNU : synonyme de NON CONNU');
    writeln('PREMIER PASSAGE : vrai lors du 1er tour des rgles, faux ensuite');
    writeln('DERNIER PASSAGE : vrai si on a fait un tour complet sans application d''aucune');
    writeln('rgle. Si sa mise  vrai dclenche une rgle, DERNIER PASSAGE est remis ');
    writeln('faux, jusqu''au prochain tour complet sans application d''aucune rgle.');
    writeln('VRAI : prdicat toujours vrai');
    writeln;
    writeln('Prdicats prdfinis utilisables en conclusion uniquement :');
    writeln;
    writeln('AFFICHER texte : affiche le texte  l''cran');
    writeln('DIRE SI prdicat : affiche si Vrai, Faux ou Inconnu');
    writeln('DEMANDER SI prdicat : demande  l''utilisateur si le prdicat est Vrai,');
    writeln('Faux ou inconnu');
    writeln('STOP : arrter le droulement des rgles');
    writeln;
    write(' appuyez une touche pour la suite');c:=readkey;clrscr;
    writeln('Description des options du menu principal :');
    writeln;
    writeln('Initialiser : tout rinitialiser et relire une BdC (On peut trouver des');
    writeln('erreurs dans la BdC en appelant cette option avec un niveau de commentaires');
    writeln('plus lev)');
    writeln('Excution : xcuter les rgles jusqu'' ordre STOP ou si plus aucune rgle');
    writeln('ne s''applique');
    writeln('Pas  Pas : excuter la rgle suivante uniquement (utile avec un niveau de');
    writeln('commentaires plus lev)');
    writeln('Modif BdF : pour chaque prdicat, dire s''il est vrai, faux ou inconnu');
    writeln('Analyse BdC : recre un fichier de rgles telles qu''il les a comprises, et');
    writeln('rajoute en commentaire en fin de fichier une dition des liens entre rgles');
    writeln('et prdicats');
    writeln('Commenter : donner un niveau de dtails sur les dductions : 0 excution');
    writeln('simple, 1 droulement (n d''tape et n de rgle, une tape est le fait');
    writeln('d''essayer d''appliquer une rgle), 2 dtails maxi.');
    writeln;
    write(' appuyez une touche pour la suite');c:=readkey;clrscr;
  end

end;

procedure lirenom(var nomfic:tstring;ext:tstring);
{lire un nom de fichier avec ajout si ncessaire d'une extension}
var nom:tstring;
begin
  if pos('.',nomfic)=0 then nomfic:=nomfic+'.'+ext;
  write('nom du fichier <',nomfic,'> ? ');
  readln(nom);
  if length(nom)>0 then
    if pos('.',nom)=0 then nomfic:=nom+'.'+ext else nomfic:=nom
end;

{variables uniquement pour le prog principal}
var rep:char;
    nomfic,nomprim,nomsauve,nombdf:tstring;


begin {programme principal}
  presentation;
  nomsauve:='analyse';nomfic:='base';nombdf:='faits';
  details:=0;
  writeln('Lecture de la base de conaissances : ');
  lirenom(nomfic,'BDC');
  lecture_bdc(nomfic);
  repeat
    writeln;
    writeln('Initialiser                 Lister base de faits');
    writeln('Execution                   Analyse BDC');
    writeln('Pas  pas                   Sauver base de faits');
    writeln('Nombre pas                  Rcuprer base de faits');
    writeln('Modif Base De Faits         Commenter le droulement');
    writeln('Fin');
    write('           votre choix ? ');
    rep:=upcase(readkey);writeln(rep);
    case rep of
      'I':begin
           del_pointeurs;
           lirenom(nomfic,'BDC');
           lecture_bdc(nomfic);
          end;
      'A':begin
           lirenom(nomsauve,'BDC');
           list_bdc(nomsauve);
          end;
      'E':tourne;
      'N':nombrepas;
      'P':begin
            derntourplus1:=derntour;
            pasapas;
            if (derntour and derntourplus1 and(dern_modif=regle^.num))or arret
              then writeln('EN MODE AUTOMATIQUE, JE M''ARRETERAI ICI')
          end;
      'L':lister;
      'M':modif;
      'S':begin lirenom(nombdf,'BDF');sauve_bdf(nombdf) end;
      'R':begin lirenom(nombdf,'BDF');recup_bdf(nombdf) end;
      'C':begin write('niveau de dtails (0..2) ? ');readln(details) end
    end;
  until rep='F';
  {del_pointeurs fait automatiqut par turbo}
end.

(*commentaires :
mot clef en 1re colonne, sinon considr comme ligne commentaire
SI {NON|CONNU|INCONNU} prdicat
ET SI ......
ALORS {NON|DEMANDER SI|DIRE SI} prdicat
ET .....
entre mots clef on peut mettre plusieurs blancs ou tab (un seul blanc
dans DEMANDER SI et DIRE SI). Un prdicat est le mme dans deux rgles
si du premier non blanc au dernier il est identique (blancs, majuscules...)

le prdicat PREMIER PASSAGE (en majuscules) est vrai au 1er passage, faux aprs
DERNIER PASSAGE est mis  faux au dernier passage. vous pouvez le remettre  vrai
VRAI est toujours vrai

*)